import { Context, Span, SpanOptions as _SpanOptions } from '@opentelemetry/api';
export type SpanOptions = _SpanOptions & {
    /** The name of the span */
    name: string;
    /** Whether we trace it */
    enabled: boolean;
    internal?: boolean;
    /** Whether it propagates context (?=true) */
    active?: boolean;
    /** The context to append the span to */
    context?: Context;
};
/**
 * Executes and traces a function inside of a child span asynchronously.
 * @param options the options for the child span.
 * @returns
 */
export declare function runInChildSpan<R>(options: SpanOptions, cb: (span?: Span, context?: Context) => R | Promise<R>): Promise<R>;
